# Niku
Create Flutter UI, easier, faster, smarter

Fluently developing without headache and Nested Hell.

![korone-drake-format](https://user-images.githubusercontent.com/35027979/153739208-a80d8ccb-84c3-4cc7-a707-3af270a4a9f2.jpeg)

## Why
###### Recommended: See why people choose and how it get along with your codebase in [the documentation](https://v2.niku.saltyaom.com)

Styling in Flutter is complex and verbose.

Developers have to describe every styling detail to Widget.
It’s like low-level programming UI, having to adapt between property is hard when some are more complex than others, for instance, MaterialStateProperty.

When the codebase gets more complex, the syntax of Flutter itself is too verbose, nested than it should be, result being hard to maintain mostly known as Nested Hell.

Niku helps to solve the problem by providing a dot cascade to style widget.
Exposing the same naming convention, shorten property, parent builder and style extraction.

Providing a smoother, shorter yet, more straightforward and maintainable way to compose styling in Flutter.

## Documentation
Documentation for v2 can be found on [v2.niku.saltyaom.com](https://v2.niku.saltyaom.com)

- [Documentation](https://v2.niku.saltyaom.com)
- [Introduction and Why](https://v2.niku.saltyaom.com/docs)
- [Quickstart](https://v2.niku.saltyaom.com/docs/quickstart)
- [Hook](https://v2.niku.saltyaom.com/docs/hook)
- [Parent](https://v2.niku.saltyaom.com/docs/parent)
- [Extending Niku](https://v2.niku.saltyaom.com/docs/extending-niku)
- [Custom Widget](https://v2.niku.saltyaom.com/docs/custom-widget)
- [Macro](https://v2.niku.saltyaom.com/docs/macro)
- [Repaint](https://v2.niku.saltyaom.com/docs/repaint)
- [UseQuery](https://v2.niku.saltyaom.com/docs/use-query)

### License
Niku is MIT Licensed.

### Maintainers
- [SaltyAom](https://github.com/saltyaom)
